
def install(self):    
    InstallationException = 'Installation error'
    try:
        from Products.CMFCore.utils import _checkPermission
    except:
        raise InstallationException, ("CMF not installed.")
    write = self.REQUEST.RESPONSE.write

    header = """
<html><head><title>CMFPortlets' installation</title>
<style type="text/css">
<!--
body{
	font-family: Verdana;
	font-size : 71%;
} -->
</style>
</head><body> """
    
    for k,v in self.portal_url.getPortalObject().objectItems():        
        if k == 'portal_membership' and v.meta_type == 'Plone Membership Tool':
            write(header)
            write("<div align='center'>CMFPORTLETS 0.5.2 INSTALLATION LOG<br>")
            write("============================</div>")            
            write("<p>Plone installation currently not supported.</p>")
            return None
    
    from Products.CMFCore.utils import getToolByName
    if _checkPermission('Manage portal', self):
        portal_root = getToolByName(self, 'portal_url').getPortalObject()
        if self != portal_root: raise InstallationException, ("You are executing the installer outside a CMF portal")

        from Products.CMFCore.DirectoryView import addDirectoryViews
        from Products.CMFPortlets import CMFPortlets_globals
        from Products.CMFCore.ActionsTool import ActionInformation as AI
        from Products.CMFCore.Expression import Expression
        from Products.CMFCore.CMFCorePermissions import View        

        ps = getToolByName(self, 'portal_skins')
        pt = getToolByName(self, 'portal_types')
        pmemship = getToolByName(self, 'portal_membership')
        pmemdata = getToolByName(self, 'portal_memberdata')            
    else:
        raise InstallationException, ("You're not authorized")


    line = 0; installation_successful = 1    
    try:
        addDirectoryViews(ps, 'skins', CMFPortlets_globals)        
    except:
        check_pt = hasattr(pt,'Portlet') and hasattr(pt,'Portlet Document') and hasattr(pt,'Portlet Topic')
        check_ps = 'CMFPortlets_skins' in ps.getSkinSelections()
        li = [x.id for x in pmemship.listActions()]
        check_pmemship = 'mypage' in li and 'viewzmi' in li
        check_pmemdata = hasattr(pmemdata, 'personal_selections')
        
        thispermission = 'Set own properties'; thisrole = 'Member'   
        per = portal_root.rolesOfPermission(thispermission)
        rolesselected = [it['name'] for it in per if it['selected']=='SELECTED'] 
        check_security = thisrole in rolesselected
        
        li0 = [check_pmemship, check_ps, check_pt, check_pmemdata, check_security]
        if 0 not in li0:        
            raise InstallationException, ('CMFPortlets already installed.')
        elif 1 in li0:
            line = """... installing over a previously installed CMFPortlets installation.<br>
&nbsp;&nbsp;&nbsp;&nbsp;You may need to manually check each setting, according to defaults.<br><br>."""


   
    write(header)
    
    write("<div align='center'>CMFPORTLETS 0.5.2 INSTALLATION LOG<br>")
    write("============================</div>")

    if line: write(line)
    
    installationok = 1

    # PORTAL TYPES CHANGES
    write('<br>PORTAL TYPES:<br>')

    if not hasattr(pt,'Portlet'):

        pt.manage_addTypeInformation('Factory-based Type Information',\
                                     id='Portlet',
                                     typeinfo_name='CMFDefault: Skinned Folder')
        pl=getattr(pt, 'Portlet')
        pl.manage_editProperties( { 'immediate_view': 'portlets_afterAdd', 
                                    'content_meta_type': 'Skinned Folder', 
                                    'global_allow': 'on', 
                                    'allowed_content_types': ['Portlet Document', 
                                                              'Portlet Topic'],
                                    'content_icon': 'folder_icon.gif', 
                                    'factory': 'addSkinnedFolder', 
                                    'product': 'CMFDefault', 
                                    'title': '', 
                                    'description': 'Portlet creation', 
                                    'filter_content_types': 'on'} )
        pl.changeActions({'action': '', 'id_1': 'edit', 
                          'action_0': 'portlet_view', 
                          'id_3': 'portletPreferences', 
                          'id_2': 'foldercontents', 
                          'visible_1': '1', 
                          'visible_0': '1', 
                          'visible_3': '1', 
                          'visible_2': '1', 
                          'name': '', 
                          'category': '',
                          'id': '',
                          'permission_3': 'Set own properties',
                          'permission_2': 'List folder contents',
                          'permission_1': 'Manage properties',
                          'permission_0': 'View',
                          'changeActions': 'Save',
                          'visible': '1',
                          'category_0': 'folder',
                          'category_1': 'folder',
                          'category_2': 'folder',
                          'category_3': 'folder',
                          'action_1': 'portlet_edit_form',
                          'action_2': 'folder_contents',
                          'permission': '',
                          'id_0': 'view',
                          'action_3': 'portlet_preferences',
                          'name_1': 'Edit',
                          'name_0': 'View',
                          'name_3': 'Portlet Preferences',
                          'name_2': 'Folder contents'})
        write("... added portal type 'Portlet'<br>")
    else:
        write("... couldn't add portal type 'Portlets' due to there's already another one with the same id.<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
        installationok = 0

    if not hasattr(pt,'Portlet Document'):    
        pt.manage_addTypeInformation('Factory-based Type Information', \
                                     id='Portlet Document',
                                     typeinfo_name='CMFDefault: Document')
        pd=getattr(pt, 'Portlet Document')
        pd.manage_editProperties({ 'factory': 'addDocument',
                                   'immediate_view': 'document_edit_form',
                                   'content_meta_type': 'Document', 
                                   'filter_content_types': 'on',
                                   'title': '', 
                                   'description': "Documents can contain text that can be formatted using 'Structured Text.'", 
                                   'global_allow': 'on',
                                   'product': 'CMFDefault',
                                   'content_icon': 'document_icon.gif'})
        pd.changeActions({'action': '', 'id_1': 'edit',
                          'action_1': 'document_edit_form',
                          'id_2': 'metadata', 'visible_1': '1',
                          'visible_0': '1',
                          'visible_2': '1', 'name': '',
                          'category': '', 'id': '',
                          'action_0': 'document_view_fportlets',
                          'permission_2': 'Modify portal content',
                          'permission_1': 'Modify portal content',
                          'permission_0': 'View', 'visible': '1',
                          'category_0': 'object',
                          'category_1': 'object', 'category_2': 'object',
                          'changeActions': 'Save',
                          'action_2': 'metadata_edit_form',
                          'permission': '', 'id_0': 'view',
                          'name_1': 'Edit', 'name_0': 'View',
                          'name_2': 'Metadata'})    
        write("... added portal type 'Portlet Document'.<br>")
    else:
        write("... couldn't add portal type 'Portlet Document' due to there's already another one with the same id.<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
        installationok = 0


    if not hasattr(pt,'Portlet Topic'):        
        pt.manage_addTypeInformation('Factory-based Type Information', \
                                     id='Portlet Topic',
                                     typeinfo_name='CMFTopic: Portal Topic')
        pto=getattr(pt, 'Portlet Topic')
        pto.manage_editProperties({'factory': 'addTopic',
                                   'immediate_view': 'topic_edit_form',
                                   'content_meta_type': 'Portal Topic', 
                                   'title': '',
                                   'description': 'Topics are canned queries for organizing content with up to date queries into the catalog.',
                                   'global_allow': 'on',
                                   'product': 'CMFTopic',
                                   'content_icon': 'topic_icon.gif'})
        pto.changeActions({'action': '', 'id_1': 'edit',
                           'action_0': 'topic_view_fportlets',
                           'id_3': 'subtopics', 'id_2': 'criteria',
                           'visible_1': '1',
                           'visible_0': '1', 'visible_3': '1',
                           'visible_2': '1', 'name': '', 'category': '',
                           'id': '', 'permission_3': 'Change portal topics',
                           'permission_2': 'Change portal topics',
                           'permission_1': 'Change portal topics',
                           'permission_0': 'View', 'changeActions': 'Save',
                           'visible': '1', 'category_0': 'object',
                           'category_1': 'object', 'category_2': 'object',
                           'category_3': 'object', 'action_1': 'topic_edit_form',
                           'action_2': 'topic_criteria_form',
                           'permission': '', 'id_0': 'view',
                           'action_3': 'topic_subtopics_form',
                           'name_1': 'Edit', 'name_0': 'View',
                           'name_3': 'Subtopics', 'name_2': 'Criteria'})
        write("... added portal type 'Portlet Topic'.<br>")
    else:
        write("... couldn't add portal type 'Portlet Topic' due to there's already another one with the same id.<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
        installationok = 0



    # PORTAL SKINS CHANGES
    write('<br>PORTAL SKINS:<br>')


    if 'CMFPortlets_skins' not in ps.getSkinSelections():
        path = ps.getSkinPath( ps.getDefaultSkin() )
        path = [x.strip() for x in path.split(',')]
        if 'custom' in path:
            path.insert( path.index('custom')+1, 'CMFPortlets' )
        else:    
            path.insert(0,'CMFPortlets')
        path = ', '.join(path)
        ps.addSkinSelection( 'CMFPortlets_skins', path )
        write("... added 'CMFPortlets_skins' skin path.<br>")
        ps.manage_properties(default_skin='CMFPortlets_skins')
        write("... 'CMFPortlets_skins' skin path set to default.<br>")
    else:
        write("... couldn't add 'CMFPortlets_skins' skin path due to there's already another one with the same id.<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
        installationok = 0

        
    cfolder = getattr(ps, 'custom', 0)
    if cfolder:
        if 'NotFoundObject' not in cfolder.objectIds():
            cfolder.manage_addDTMLDocument('NotFoundObject')
            write("... added object 'NotFoundObject' to the 'custom' folder.<br>")
            doc = getattr(cfolder, 'NotFoundObject')
            doccontent = """<dtml-comment>
Used by 'portlets_RenderingEngine' to render a replacement box when the selected by the user can't be found
</dtml-comment>
<p>&nbsp;</p>The selected portlet can't be displayed. Either it was renamed or deleted, or you don't have the privileges
to view all or part of its content.<br>You may remove this box.<p>&nbsp;</p>"""
            doc.manage_edit(doccontent, 'Portlet not found!...')
        else:
            write("... couldn't add 'NotFoundObject' to the 'custom' folder due to there's already an object with the same id.<br>")
            write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
            installationok = 0

        if 'portlets_afterAdd' not in cfolder.objectIds():
            from Products import ExternalMethod
            ExternalMethod.ExternalMethod.manage_addExternalMethod(cfolder, 'portlets_afterAdd', 'Auxiliar to portlet creation',
                                                                   'CMFPortlets.portlets_afteradd', 'portlets_afteradd')
            write("... added object 'portlets_afterAdd' to the 'custom' folder.<br>")
        else:
            write("... couldn't add 'portlets_afterAdd' to the 'custom' folder due to there's already an object with the same id.<br>")
            write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
            installationok = 0

            
        
    cmfportletsfolder = getattr(ps, 'CMFPortlets')
    try:
        cmfportletsfolder.page_view_fdefault.manage_doCustomize(folder_path='custom')
        cfolder.page_view_fdefault.manage_renameObject('page_view_fdefault', 'page_view' )
    except:
        if 'page_view' in cfolder.objectIds():
            write("... couldn't add 'page_view' zpt (CMFDefault version) to custom folder, due to there's already an object with the same id.<br> ")
            write("&nbsp;&nbsp;&nbsp;&nbsp;You may have installed CMFPortlets before.<br>")
        else:
            write("... couldn't add 'page_view' zpt (CMFDefault version) to custom folder, due to an unhandled error.<br> ")
        installationok = 0


            
    # PORTAL MEMBERSHIP CHANGES
    write('<br>PORTAL MEMBERSHIP:<br>')
    
    e = pmemship._cloneActions()
    
    if type(e) == type(()):
        e = list(e)

    newit1 = AI( id='mypage'
    , title='My Page'
    , description='Click here to open your workspaces'
    , action=Expression(text='string:${portal_url}/page_view')
    , permissions=(View,)
    , category='user'
    , condition=Expression(text='python: member')
    , visible=1 )

    newit2 = AI( id='viewzmi'
    , title=' ZMI '
    , description='Click here to open the ZMI management interface.'
    , action=Expression(text='string:${object_url}/manage_main')
    , permissions=('View management screens',)
    , category='user'
    , condition=Expression(text='python: member')
    , visible=1 )

    li = [x.id for x in e]
    if 'mypage' not in li:
        e.insert( 0, newit1 )      
        write("... action 'My Page' added.<br>")
    else:
        write("... action 'My Page' wasn't added due to there's already an action with the id 'mypage'.<br>")
        installationok = 0
    if 'viewzmi' not in li:
        e.append( newit2 )
        write("...action 'ZMI' added.<br>")
    else:
        write("...action 'ZMI' wasn't added due to there's already an action with the id 'viewzmi'.<br>")
        installationok = 0

    pmemship._actions = tuple( e )



    # PORTAL MEMBERDATA CHANGES:
    write("<br>PORTAL MEMBERDATA:<br>")

    if not hasattr(pmemdata, 'personal_selections'):
        pmemdata.manage_addProperty('personal_selections', [], 'lines' )
        write("... added property 'personal_selections'.<br>")
    else:
        write("... couldn't add property 'personal_selections' due to there's already a property with the same id.<br>")
        write("    You may have installed CMFPortltes.")
        installationok = 0

    

    # PORTAL SECURITY CHANGES:
    write("<br>SECURITY SETTINGS:<br>")
    thispermission = 'Set own properties'; thisrole = 'Member'            
    try:
        
        per = portal_root.rolesOfPermission(thispermission)
        rolesselected = [it['name'] for it in per if it['selected']=='SELECTED']   
        if thisrole not in rolesselected:
            rolesselected.append(thisrole)
            doesacquire = portal_root.acquiredRolesAreUsedBy(thispermission)
            if doesacquire =='CHECKED': doesacquire = 1
            else: doesacquire = 0                
            newtuple = tuple(rolesselected)
            portal_root.manage_permission(thispermission, newtuple, acquire=doesacquire)
            write("... permission '%s' granted to role '%s', at the portal root.<br>" % (thispermission, thisrole) )
            write("&nbsp;&nbsp;&nbsp;&nbsp;No other security settings were touched.<br>")
        else:
            write("... permission '%s' is already granted to role '%s', at the portal root.<br>" % (thispermission, thisrole))
            write("&nbsp;&nbsp;&nbsp;&nbsp;No changes made to your security settings.<br>")
    except:
            write("... permission '%s' couldn't been granted to role '%s', at the portal root.<br>" % (thispermission, thisrole))
            installationok = 0
        
    

    # OPTION CHOOSER and DYNAPI IMPORT:
    write("<br>OPTION CHOOSER IMPORT:<br>")
    
    try:
        portal_root.manage_importObject(file="OptionChooser.zexp", set_owner=1)
        write("... Option Chooser and Dynapi software imported sucessfully.<br>")
        from Products.CMFPortlets import OCH_Cache
        dict = OCH_Cache.assoc_dict       
        portal_root.OptionChooser.cache_option_chooser.ZCacheManager_setAssociations(dict)
        write("... accelerated cache associations for OptionChooser's folder contents performed.<br>")
    except:
        write("... couldn't import Options Chooser and Dynapi software.<br> ")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may need to try a manual import, verifying OptionChooser.zexp is placed<br>") 
        write("&nbsp;&nbsp;&nbsp;&nbsp;correctly within your 'import' folder. You're also encouraged to manualy perform<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;the cache associations within the 'cache_option_chooser' cache manager.<br>")
        installationok = 0

            

    
    # SAMPLE PORTLETS IMPORT:
    write("<br>SAMPLE PORTLETS IMPORT:<br>")
    try:
        portal_root.manage_importObject(file="SamplePortlets.zexp", set_owner=1)
        write("... SamplePortlets folder imported sucessfully.<br>")
    except:
        write("... couldn't import SamplePortlets folder.<br>")
        write("&nbsp;&nbsp;&nbsp;&nbsp;You may need to try a manual import, verifying SamplePortlets.zexp<br>") 
        write("&nbsp;&nbsp;&nbsp;&nbsp;is placed correctly within your 'import' folder.<br>")
        installationok = 0


    if installationok:        
        write("<h4>Installation sucessful!.</h4>You may now delete the installer.")
    else:
        line = """
<h4>Partial installation.</h4>At least one item couldn't been set according to defaults.<br>
Chances are that you've installed CMFPortlets previously. If that is the case, you need to configure it manually."""
        write(line)

        


