## Script (Python) "portlets_RenderingEngine"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Main layout renderer
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


REQUEST = context.REQUEST
objectBypath = context.restrictedTraverse

implementation = 'default'
if hasattr(context, 'cmf_implementation') and context.cmf_implementation == 'plone':
    implementation = 'plone'


# ESTABLISHING THE PORTLETS SOURCE:
content_boxes = context.portlets_available() #  the portlets can be anywhere as they are retrieved by means of a search to the catalog.


# SOME GENERAL ATTRIBUTES:
if implementation == 'plone':
    left_margin = '11'   # in pixels
    forms_style_string = ''
else:
    left_margin = '0'
    forms_style_string = "style='font-size:9pt;'"    # default style to forms. Looks fine in PC.
right_margin = left_margin   # in pixels


# HELPER METHODS:
def available_boxes(content_boxes, cols_list):   #each col is a list of (id,url) tuples        
    tot_opt = ''
    existing_cols = cols_list
    supercol = []
    for col in existing_cols:
        supercol = col + supercol
    supercol_urllist = [v for (k,v) in supercol]
    for id,url,title,rs in content_boxes:       
        #record = (id, url)   #deprecated
        record = url        
        if not (record in supercol_urllist) and rs != '':       #narrows the boxes list in the pull-down menu.
            opt = "<option value=%s@@%s >%s</option>" % (id, url, title)
            tot_opt = tot_opt + opt
    # FORCED ENTRY, just for its use with SamplePortlets.
    # Uncomment the following two lines if you want to add FolderViewer more than once.
    # tot_opt = tot_opt + "<option>-------------</option>" + \
    # "<option value=%s@@%s >%s</option>" % ('FolderViewer', 'SamplePortlets/FolderViewer', 'Folder display')
            
    return tot_opt

def reset():
    default_selections = [
                    ['p1',
                         {'ptitle': 'Untitled page',
                          'pcolums': [
                                  ['column1', [], {'col_width': '0' }],
                                  ['column2', [], {'col_width': '0'}]
                                     ],
                          'pwidth':'100%',
                          'pcellspace':'0',
                          'pcellpad':'3',
                          'palign':'center',
                          'pstylesheet_fixed':[],
                          'pstylesheet_dyn':[],
                          'pscript_fixed':[],
                          'pscript_dyn':[]
                          }
                     ],
                         ]
    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=default_selections)
    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=p1')


def column_options(p,col,av_boxes,av_boxskins,colw,empty):
    header = """<table bgcolor="#D2FFED" border="1" width=100% bordercolor="#7DFFCB" cellpadding="0" cellspacing="0"><tr><td align="center">"""
    footer = """</td></tr></table>"""
    if empty==1:
        emp_header = """<h3>Empty column</h3>Select one by one the sections you want to add to this column, and then click on 'Add'.<br>
If you don't want to use it, you may <a href=portlets_garage?delete=column&p=%s&col=%s >delete this column</a>.""" % (p,col)
    else: emp_header = ''    
    colopt = """<form action=portlets_garage method=get ><select %s name=portlet ><option>Add a section box</option> %s </select><input type="hidden"
    name="p" value="%s" ><br/><input type="hidden" name="col" value="%s" >%s<input type='submit' %s name='add_content' value=' Add '></form>
<a href=portlets_garage?delete=column&p=%s&col=%s >delete column</a><form action=portlets_garage method=get ><input type="text" %s name="ncolw"
size="5" value=%s><input type='submit' name='new_width' %s value='Change width'><input type="hidden" name="p" value="%s" ><input type="hidden"
name="col" value="%s" ><br><font face="Arial, Helvetica, sans-serif" size="1">0=no width information.</font> </form><img src='spacer.gif'
width=%s height=5>""" % (forms_style_string, av_boxes, p, col, av_boxskins, forms_style_string, p, col, forms_style_string, colw, forms_style_string, p, col, colw)  
    return header + emp_header + colopt + footer


# START OF THE PAGE(WORKSPACE) RENDERING

if REQUEST.has_key('p'):
    # CALLING THE MEMBER PORTLETS RECORD.
    p = REQUEST.p   # we get the page number from the request.
    ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')  # the record
    numpags = len(ps)  # the number of pages stored in the record.
    #print ps
    #return printed
    windowName = "PORTLETSPAGE%s" % (p)
    print """
<script>
window.name="%s";
</script> """ % (windowName)   
      
    try:    # this whole script lacks a convenient error handling. 
        if numpags != 0:
            td_width = 100 / numpags
        else:
            return "Not handled error. Please ask the administrator"
        if REQUEST.has_key('manage_page') and REQUEST.manage_page == '1':
            REQUEST.RESPONSE.setCookie('view_manage_options', '1', path='/')
            vmo = '1'
        elif REQUEST.has_key('manage_page') and REQUEST.manage_page == '0':
            REQUEST.RESPONSE.setCookie('view_manage_options', '0', path='/')
            vmo = '0'        
        elif REQUEST.has_key('view_manage_options') and REQUEST.view_manage_options == '1': 
            vmo = '1'
        elif REQUEST.has_key('view_manage_options') and REQUEST.view_manage_options == '0': 
            vmo = '0'
        else:
            vmo = '0'    

        # CONFIGURATION OPTIONS RENDERING
    

        if vmo == '1' :
            
            for x in range(numpags):
                if ps[x][0] == p:
                    page_width, page_align = ps[x][1]['pwidth'], ps[x][1]['palign']  # values for the current page
                    #page_cellspace, page_cellpad = ps[x][1]['pcellspace'], ps[x][1]['pcellpad']
                    columns_in_page = len(ps[x][1]['pcolums'])
                    try:
                        page_cellspace, page_cellpad = ps[x][1]['pcellspace'], ps[x][1]['pcellpad']
                    except:
                        page_cellspace, page_cellpad = '0', '3'                    
                    break

            # FOR THE INTERACTIVE ARRANGER'S SAKE
            pop_width = 115 * (columns_in_page + 1) + 35

            len_content_boxes = len(content_boxes)
            if len_content_boxes == 0:
                pop_height = 200
            else:          
                pop_height = (20 + 1 ) * len_content_boxes + 150
                if pop_height > 550: pop_height = 550
                elif pop_height < 200: pop_height = 200
            print """
<script>
function openWindow()
{
   var w = window.open ("portlets_option_chooser?p=%s&winname=%s", "w%s", "height=%s,width=%s,scrollbars=yes");
}
</script> """ % (p, windowName, str(int(DateTime())), pop_height, pop_width)


            print """
<table width=100%% bgcolor="#D2FFED" border="0" cellspacing="0" cellpadding="2" style="font-size:8pt; font-family:Arial; font-color:#336699;">
<tr><form method="post" action="portlets_search"><td rowspan="2" valign="middle" width=11%%><div align="center">Search portlets:<br><input type="text"
name="searchPortlets_field" size="11"><input type="submit" name="top_panel"  value="Search" %s></div></td></form><form method=get
action="portlets_garage"><td align=center width=81%% valign="bottom" > Page width:<input type="text" %s name="npagew" size="4" value=%s
maxlength="4">Cellpad: <input type="text" %s name="npage_cellpad" size="4" value=%s maxlength="4">Cellspace:<input type="text" %s
name="npage_cellspace" size="4" value=%s maxlength="4"><input type='submit' name='change_pagetable' value='Change' %s ><input type="hidden"
name="p" value="%s"><select name=npalign %s >
""" % (forms_style_string, forms_style_string, page_width, forms_style_string, page_cellpad, forms_style_string, page_cellspace, forms_style_string, p, forms_style_string)
            li = ['center', 'left' , 'right']
            for elem in li:
                if elem == page_align and elem == 'center':
                    print "<option value='%s' selected > %s (default)</option>" % (elem, elem)
                elif elem != page_align and elem == 'center':
                    print "<option value='%s'> %s (default)</option>" % (elem, elem)
                elif elem == page_align:
                    print "<option value='%s' selected > %s </option>" % (elem, elem)
                else:
                    print "<option value='%s'> %s </option>" % (elem, elem)
            print """ </select></td></form>
<td align=center rowspan="2" valign="middle" width=8%%><img src='cmfportletslogo.gif' width=70 alt="portlets by CMFPortlets 0.5.2"
height=26 border="0"><br><a href=%s/page_view?p=%s&manage_page=0>Hide options</a></td></tr><tr><td align=center width=81%% ><a
href=portlets_garage?add=column&p=%s >ADD COLUMN</a> &nbsp;&nbsp;&nbsp;<a href=portlets_garage?add=row&p=%s >ADD ROW</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp;<a href=portlets_garage?add=page> ADD PAGE</a>&nbsp; &nbsp;&nbsp;&nbsp;<a href=portlets_garage?delete=page&p=%s >DELETE PAGE</a>&nbsp;&nbsp;&nbsp;
&nbsp;<a href=portlets_garage?rename=page&p=%s >RENAME PAGE</a>&nbsp;&nbsp;&nbsp;&nbsp; <a href="javascript:openWindow()" >INTERACTIVE</a></td>
</tr></table> """ % ( context.absolute_url(), p,p,p,p,p, )
        
        for x in range(numpags):   ##start of the iteration. numpags is the number of pages
            if ps[x][0] == p: # when the iteration finds the value for the page is being requested, we start rendering it                
                column_contents = ps[x][1]['pcolums']   # a list of columns and its complete attributes. (Columns are lists).            :
                aux =  [portlet for numcol,portlet,colprop in column_contents]  # ps[x][1]['pcolums'] in this context is the list of values for the column
                                                           #aux is the list of existing boxes in each column ( a list of lists)
                
                # COLUMN WIDTHS CALCULATION. By default the width is set to the percentage resulting from dividing 100% by the number of columns, unless
                                            # the user sets a fixed width in pixels for at least one of the columns.

                columns_widths_list = [colprop['col_width'] for numcol,portlet,colprop in column_contents]
                use_global_width = 1 #colw = 'empty_value'
                colw = 'somevalue'
                for w in columns_widths_list:
                    if w != '0':
                        use_global_width = 0
                        break
                if use_global_width == 1:           
                    if len(aux) != 0:
                        global_width = str(100 / len(aux)) + '%'
                    else:
                        global_width = '100%'   

                # PAGE PROPERTIES        # need to find something better
                try: page_width = ps[x][1]['pwidth']
                except: page_width = "100%"
                try: page_align = ps[x][1]['palign']
                except: page_align = 'center'
                try: page_cellspace = ps[x][1]['pcellspace']
                except: page_cellspace = '0'
                try: page_cellpad = ps[x][1]['pcellpad']
                except: page_cellpad = '3'                
                try: page_stylesheet = ''
                except: page_stylesheet = ''
                  
                # TABLE INIT

                if left_margin == '0':
                    print """<table width=%s align=%s cellspacing=%s cellpadding=%s ><tr valign=top>""" % (page_width, page_align, page_cellspace, page_cellpad )
                else:                
                    print """<table width=%s align=%s cellspacing=%s cellpadding=%s ><tr valign=top><td rowspan="2" width='%s'><img src='spacer.gif' width=%s
                    height=5></td>""" % (page_width, page_align, page_cellspace, page_cellpad, left_margin, left_margin)

                # TABS RENDERING.- Needs more work
                
                print "<!---start tabs -->"                

                print """<td colspan=%s >""" % (len(column_contents)) # the number of pages plus the 'Configure' cell


                if implementation == 'plone':
                    print "<table width=100% ><tr><td><div class=tabs>"                
                    for k,v in ps:
                        if p == k:   
                            print """<A class=selected href="%s/page_view?p=%s">%s</A><SPAN class=netscape4></SPAN>"""   % (context.absolute_url(),k,v['ptitle'])
                        else:
                            print """<A class=plain href="%s/page_view?p=%s">%s</A><SPAN class=netscape4></SPAN>"""   % (context.absolute_url(),k,v['ptitle'])                                                 
                    print "</div>"    
                    if vmo =='0': print"""</td><td bgcolor=#D2FFED width=1%%><a href=%s/page_view?p=%s&manage_page=1 >Configure</a>""" % (context.absolute_url(),p)
                    print "</td></tr></table>"
                else:
                    print "<table width=100% bgcolor=#F0F0F0 ><tr>" 
                    for k,v in ps:
                        if p == k:    
                            print "<td bgcolor=#FFFFFF align=center width=" + str(td_width) + "% >"
                        else:                        
                            print "<td align=center width=" + str(td_width) + "% >"
                        print """<a href="%s/page_view?p=%s">%s</a>""" % (context.absolute_url(),k,v['ptitle'])                
                    if vmo == '0' :
                        print """<td bgcolor=#D2FFED >
                        <a href=%s/page_view?p=%s&manage_page=1 >Configure</a></td>""" % (context.absolute_url(), p )
                    print "</tr></table>"

                if left_margin == '0':
                    print "</td></tr>"  
                else:
                    print "</td><td rowspan='2' width=%s><img src='spacer.gif' width=%s height=5></tr>"    % (right_margin, right_margin)

              
                print "<!-- end tabs -->"



                # MAIN TABLE RENDERING

                
                print "<tr valign=top>"

                cols_list = []                
                for elem in range(len(aux)):
                    currentcol = aux[elem]
                    currentcol = [(x[0],x[1]) for x in currentcol] 
                    cols_list.append(currentcol)
                        
                av_boxes = available_boxes(content_boxes, cols_list)


                # START COLUMN RENDERING
                
                for column in range(len(aux)):  
                    col = str( column + 1 )  # col is the column number. Must change to column_num instead. 
                    if len(aux[column]) != 0:
                        
                        if use_global_width == 0:
                            colw = columns_widths_list[column]
                            if colw == '0':
                                print """<td xx valign="top">""" #% (colw)
                            else:
                                print """<td kk width=%s valign="top">"""  % (colw)
                        else:
                            colw = global_width
                            print """<td yy width=%s valign="top">"""  % (colw)                       
                        if vmo == '1':
                            print """<font face="Arial, Helvetica, sans-serif" size="1">column width: %s</font><br>""" % (colw) #(columns_widths_list[column])
                        for k in aux[column]:             # where k is each stored call to a box


                            try:
                                plet = objectBypath(k[1])            
                                pletTitle = plet.Title()
                                portlet_userproperties = k[2]
                                box_skin = portlet_userproperties['box_skin']                               
                                pletView = plet.portlet_view(portlet_userproperties)   # <----------- THE PORTLET CONTENT. 
                                box_padding = getattr(plet,'box_padding', 0)
                                edit_url = plet.absolute_url() + "/portlet_settings"                                
                            except:
                                pletTitle = context.NotFoundObject.title
                                pletView = context.NotFoundObject()                                
                                box_skin = 'default'
                                box_padding = 8
                                edit_url = 0
                                box_properties2 = 'no hay'
                            
                            if vmo == '1':
                                print """<font face="Arial, Helvetica, sans-serif" size="1">box skin: %s</font><br>""" % (box_skin)
                                
                            # START RENDERING EACH BOX

                            print context.portlets_BoxBuilder(pletTitle, pletView, p=p, col=col, box=k[0], use_table=box_padding, 
                                                              box_skin=box_skin, edit_url=edit_url, vmo=vmo)
                            if vmo == '1':                            
                                print """<form method='get' action='portlets_garage' ><div align=center>%s<input type='submit' name='getnew_boxskin'
%s value='Change'><input type="hidden" name="p" value="%s"><input type="hidden" name="col" value="%s" ><input type="hidden" name="box"
value="%s" ><input type="hidden" name="box_skin" value="%s" ></div></form>""" % (context.portlets_availableBoxSkins(forms_style_string),
                                                                                 forms_style_string, p, col, k[0], box_skin)                                
                            else:                                        
                                print "<table border=0 cellpadding=0 cellspacing=0><tr height=7><td></td></tr></table>"
                                
                            # END BOX RENDERING
                            
                        if vmo == '1':
                            print column_options(p,col,av_boxes,context.portlets_availableBoxSkins(forms_style_string),colw,empty=0)
                        print "<img src='spacer.gif' width=%s height=5></td>" % (colw)   # a convenient transparent spacer to fixed width columns.
                        
                    else:   # THERE'S NO PORTLET AT THE COLUMN
                        if use_global_width == 0:
                            colw = columns_widths_list[column]
                            if colw != '0' and colw !=0 :
                                print """<td zz width=%s>""" % (colw)
                            else:
                                colw = ''
                                print """<td aa width=%s>""" % (colw)
                        else:
                            colw = global_width
                            print """<td bb width=%s valign="top">"""  % (colw)
                        print column_options(p,col,av_boxes,context.portlets_availableBoxSkins(forms_style_string),colw,empty=1 )                           
                        print "<img src='spacer.gif' width=%s height=5></td>" % (colw)
                print "</tr></table>"
                break                
    except:
        raise
        #print "an error anywhere"
else:
    ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
    if ps is None or ps in [[''],[' '],'',[],'[''].']:        
        reset()
    else:        
        return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=p1')
                 
            
return printed
