## Script (Python) "portlets_getInteractive"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Interactive layout form data processor
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


REQUEST = context.REQUEST
windname = REQUEST.windname

p = REQUEST.p   # we get the page number from the request. 
ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')  # the record
page_slotnum = 0  # the current workspace slot in the whole 'ps' variable. Will be finded by PAGE SLOTNUM FINDER
try:
    numpags = len(ps)  # the number of pages stored in the record.
except:
    return "<html><h1>Unhandled error</h1>Please close the window and open it again</html>"
columns_number = int(REQUEST.cols)
temp = ps


# PAGE SLOTNUM FINDER. Also performs a simple check to make Interactive Layout(IL) to display the proper window sizes,
# when columns are added from the main workspace.
for x in range(len(temp)):
    if temp[x][0] == p:
        page_slotnum = x
        the_page = temp[x][1]
        columns_inpage = temp[x][1]['pcolums']
if len(columns_inpage)!= columns_number:
    return REQUEST.RESPONSE.redirect("%s/portlets_option_chooser?p=%s&resize=1&windname=%s"%(context.absolute_url(), p, windname))


content_boxes = context.portlets_available()
items_list = [(x[0],x[1]) for x in content_boxes] # a list of (id,path) tuples from available items


# This function allows us to retrieve the admin-defined properties set, when we add portlets from IL.
objectBypath = context.restrictedTraverse             
def get_properties(portlet_url):
    try:
        pl = objectBypath(portlet_url)       
    except:
        return {'box_skin': 'default'}
    user_props_sheet = pl.propertysheets.get('portlets_user_properties')
    user_props = user_props_sheet.propertyMap()
    prop_value = user_props_sheet.getProperty
    dict = {}
    for it in user_props:
        dict[it['id']] = [prop_value(it['id']), it['type']]
    dict['box_skin'] = 'default'
    return dict
    

# A simple list of existing portlets in the page, without any boundaries. We'll use this to get paths and properties, prior to
# ask the main available portlets list.
deployed_portlets_list = []
colwidths_list = []
for x in range(len(columns_inpage)):
    colwidths_list.append(columns_inpage[x][2]['col_width'])
    for y in columns_inpage[x][1]:
        deployed_portlets_list.append(y)

#print "colwidths_list:\n\n", colwidths_list, "\n\n"
#print "deployed_portlets_list", deployed_portlets_list  # a simple list of existing portlets, wiped out of column information.Carry extra-information like box-skin   

# adding already setup properties:
def portlet_slot(thisOne):  
    this_slot = []
    for id,path,properties in deployed_portlets_list:
        if id == thisOne:
            this_slot = [thisOne,path,properties]
    if this_slot == []:
        for id,path in items_list:
            if id == thisOne:
                this_slot = [thisOne, path, get_properties(path)]     #we need to look for properties sets defined by the admin.
    return this_slot     # this is the final, single portlet slot that will be placed inside 'temp'. 


# REARRANGING PORTLETS IN CURRENT PAGE:
# Needs several steps. First we need to temporary store all relevant information from the current page and its portlets. Then
# we replace the information for the whole page, according to the new arrangement defined at 'complete_form_list'.


# A simple list of all headers. OptionsChooser does provide info only when a column has items within. We create the rest from
# the number of columns we included in the REQUEST.
column_headers_list = []  
for x in range(columns_number):
    e = "rchoices%s[]" % (x)
    column_headers_list.append(e)

# A derivation from the above. In cases where there isn't data, we consider the column as an empty list
complete_form_list = []  
for x in column_headers_list:
    try:
        significate = REQUEST.form[x]
        if same_type(significate, ''):
            significate = [significate,]        
        e = x, significate
        complete_form_list.append(e)
    except:
        e = x, []
        complete_form_list.append(e)

# Rebuilding start:
new_pcolums = []

for x in range(len(complete_form_list)):    
    li = []
    new_column_id = str(x+1)
    li.append('column'+ new_column_id)
    nli = []
    for y in complete_form_list[x][1]:
        new_portlet_slot = portlet_slot(y)
        nli.append(new_portlet_slot)
    li.append(nli)
    new_col_width = colwidths_list[x]
    li.append({'col_width':str(new_col_width)})
    new_pcolums.append(li)

#print "super_li:\n\n", new_pcolums, "\n\n"       
temp[page_slotnum][1]['pcolums']= new_pcolums
context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)

#return printed


return REQUEST.RESPONSE.redirect("%s/portlets_option_chooser?p=%s&windname=%s"%(context.absolute_url(), p, windname))
