## Script (Python) "portlets_option_chooser"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Interactive layout renderer
##
#    CMFPortlets 0.5.2  
#    Portlets for the CMF. February 5th, 2003. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt
#
#    This script uses Option Chooser 1.0, javascript code by Dan George, relying on the
#    DynAPI 2.5.6 library. See license and credits info within the distribution file,
#    "OptionChooser1.0_DynAPI2.5.6.src.zip", found at CMFPortlets download page.



content_boxes = context.portlets_available()
if content_boxes == []:
    output = """<html><head><title>CMFPortlets 0.5.1 - Interactive Layout</title>
<body bgcolor="#D2FFED" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<p>&nbsp;</p>
<p>&nbsp;</p>
<blockquote><p>You haven't created any portlet, and/or there aren't available portlets for your 
access level in this context.
</p></blockquote>
</body></html> """
    return output

scripts_url = context.portlets_option_chooser_url() 

# CALLING THE MEMBER PORTLETS RECORD.
REQUEST = context.REQUEST
p = REQUEST.p   # we get the page number from the request.


if REQUEST.has_key('winname'): # winname is the name of window coming from the original page
    windname_topass = REQUEST.winname

reload_value = str(int(DateTime())) # we'll use this to generate a number to associate to the key 'reload', just to avoid cached pages.

# GENERATING CODE TO RELOAD THE ORIGINAL PAGE:
if REQUEST.has_key('windname'):  # the name of the window after submitting the form
    window_updater = """
<SCRIPT type=text/javascript>
<!--
window.open("%s/page_view?p=%s&reload=%s", "%s" );
//-->
</SCRIPT>
""" % (context.absolute_url(), p, reload_value, REQUEST.windname)
    windname_topass = REQUEST.windname
else:
    window_updater = ''


ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')  # the record
numpags = len(ps)  # the number of pages stored in the record.

item_height = 20
itemh_forspacingcalc = 20 + 1

len_content_boxes = len(content_boxes)
height = itemh_forspacingcalc * len_content_boxes + 93
pop_height = itemh_forspacingcalc * len(content_boxes) + 178
if len_content_boxes == 0:
    pop_height = 200
else:          
    pop_height = (20 + 1 ) * len_content_boxes + 150
    if pop_height > 550: pop_height = 550
    elif pop_height < 200: pop_height = 200


# NUMBER OF COLUMNS CALCULATION:
for x in range(numpags):
    if ps[x][0] == p:
        arrange = ps[x][1]['pcolums'] 
        break
number_cols = len(arrange)


# GETTING JAVASCRIPT CODE FOR RESIZING PURPOSES:
if REQUEST.has_key('resize'):
    onload_string = ''  
    pop_width = 115 * (number_cols + 1) + 35
    resizer_script = """
window.resizeTo( %s,%s );
"""  % (pop_width, pop_height)
else:
    onload_string = ''
    resizer_script = ''


# PAGE RENDERING:
page = """
<html>
<head><title>CMFPortlets 0.5.1 - Interactive Layout</title>
<Script language="Javascript" src="%sdynapi/src/dynapi.js"></script>
<Script language="Javascript">


/* This free script is by Dan George (dangeorge.com)
   see license.txt for copyright information */

//Variables to deal with some browser incompatibility issues that DynAPI doesnt address
browser1 = (document.layers)? true:false
browser2 = (document.all)? true:false
browser3 = (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.indexOf("Mac") != -1);
var agt = navigator.userAgent.toLowerCase(); browser4 = ((agt.indexOf("msie 5.0") != -1) && (agt.indexOf("mac") != -1));

//Init-type functions
function preloadImages() {
	var d=document;
	if (d.images) {
		if (!d.pre) d.pre=new Array();
		var i,j=d.pre.length,a=preloadImages.arguments;
		for (i=0; i<a.length; i++) if (a[i].indexOf("#")!=0) {d.pre[j]=new Image; d.pre[j++].src=a[i];}}}
function redo() {window.location.reload()}
function init() {setTimeout("DynAPI.onResize = redo", 500)}

DynAPI.setLibraryPath('%sdynapi/src/lib/')
DynAPI.include('dynapi.api.*')
DynAPI.include('dynapi.event.*')
DynAPI.include('dynapi.ext.inline.js')
DynAPI.onLoad=function() {



//Start user-provided content

%s

//End user-provided content


//Make arrays to keep track of the choices
	leftChoices=new Array()
	choicesLNames=new Array()
	choicesLAtribs=new Array()

//Find number of select(right-hand) columns
	numSelCols= 0;
	for (var i=0; i<allRightChoices.length; i++) {numSelCols++}

//Set things that depend on the number of select columns
	listItemWidth= (bigLWidth-(listsLeftOMargin*3)-(listsLeftMargin*(3+numSelCols)))/(numSelCols+1);
	selectedListWidth= (numSelCols*(listItemWidth+listsLeftMargin)+listsLeftMargin);
	optionListWidth= listItemWidth+(2*listsLeftMargin);
	selColWidth= listItemWidth+listsLeftMargin;
	listsHeight= bigLHeight-listsTopOMargin-listsLeftOMargin-descHeight-33;
	listSep= listItemSep + listItemHeight;

//Initialize the selected-column title layers
	for (var i=0; i<numSelCols; i++) {
		eval("rightChoices"+i+"=new Array()")
		eval("colTLayer"+i+"=new DynLayer(null,"+((listsLeftMargin/2)+(selColWidth*i))+",selTitleMargin,(listItemWidth+listsLeftMargin),(selTopMargin-selTitleMargin),'',1,0,null,'<center><b>"+allRightChoices[i]+"</b></center>')")
		eval("linePlace= ("+i+"*selColWidth) + (listsLeftMargin/2)")
		if (i != 0) {eval("sepLineLayer"+i+"=new DynLayer(null,linePlace,0,1,(listsHeight-2),'',1,0,null,'<img src=\\"%s/images/sepLine.gif\\" height=\\""+(listsHeight-2)+"\\">')")}} // '<img src=\\"s/images/sepLine.gif\\" height=\\""+(listsHeight-2)+"\\">'                                     

//Initialize the background layers
	if (browser1 || browser4) {bigLayer = this.document.getAll()['bigLN']} else {bigLayer = this.document.getAll()['bigL']; if (!browser3) {bigLayer.moveTo(0,null)}}
	bigLayer.setSize(bigLWidth,bigLHeight); bigLayer.setBgColor('#D2FFED'); //bigLayer.setBgImage('http://localhost:92/images/bigLback.jpg');
	leftLayer=new DynLayer(null,listsLeftOMargin,listsTopOMargin,optionListWidth,listsHeight,'#FFFFFF')
	rightLayer=new DynLayer(null,optionListWidth+(listsLeftOMargin*2),listsTopOMargin,selectedListWidth,listsHeight,'#FFFFFF')
	leftBLayer=new DynLayer(null,listsLeftOMargin-2,listsTopOMargin-2,optionListWidth+4,listsHeight+4,'#bbbbbb')
	rightBLayer=new DynLayer(null,optionListWidth+(listsLeftOMargin*2)-2,listsTopOMargin-2,selectedListWidth+4,listsHeight+4,'#bbbbbb')
	descLayer=new DynLayer(null,listsLeftOMargin,listsTopOMargin+listsHeight+listsLeftOMargin,bigLWidth-(2*listsLeftOMargin),descHeight,'#B8E1D1',1,0,null,'<font style="font-size:8pt; font-family:Arial; font-color:#336699;">CHOOSE YOUR PORTLETS</font>')
	descBLayer=new DynLayer(null,listsLeftOMargin-2,listsTopOMargin+listsHeight+listsLeftOMargin-2,bigLWidth-(2*listsLeftOMargin)+4,descHeight+4,'#D2FFED')
	submitLayer=new DynLayer(null,(bigLWidth/2)-40,listsTopOMargin+listsHeight+listsLeftOMargin+descHeight+4,80,25,'',1,0,null,'&nbsp;<img STYLE=cursor:hand; src="%simages/submit.gif" border=0>&nbsp;')
	optionsTitleLayer=new DynLayer(null,(optionListWidth/2)+listsLeftOMargin-30,5,60,20,'',1,0,null,'<font style="font-size:8pt; font-family:Arial; font-color:#336699;">AVAILABLE</font>')
	selectedTitleLayer=new DynLayer(null,((bigLWidth-listsLeftOMargin-optionListWidth)/2)+listsLeftOMargin+optionListWidth-30,5,60,20,'',1,0,null,'<font style="font-size:8pt; font-family:Arial; font-color:#336699;">SELECTED</font>')

//Initialize Choices
	nextLeftSpot=leftLayer.getY()+optionsTopMargin;
	for (var i=0; i<startLeftChoices.length; i++) {
		atribs=startLeftChoices[i].split('|')
		eval("Layer"+i+"=new DynLayer("+atribs[0]+","+(leftLayer.getX()+listsLeftMargin)+","+nextLeftSpot+","+listItemWidth+","+listItemHeight+","+atribs[4]+",1,0,null,"+atribs[1]+")")
		eval("leftChoices[leftChoices.length] = "+atribs[0])
		choicesLNames[choicesLNames.length] = "Layer"+i
		choicesLAtribs[choicesLAtribs.length] = atribs
		nextLeftSpot+=listSep;}
	for (var j=0; j<numSelCols; j++) {
		eval("nextRightSpot"+j+"=rightLayer.getY()+selTopMargin;")
		ct=choicesLNames.length;
		eval("startRightChoices= stRightChoices"+j)
		for (var i=ct; i < startRightChoices.length + ct; i++) {
			eval("atribs=stRightChoices"+j+"[i-ct].split('|')")
			eval("nextRightSpot=nextRightSpot"+j)
			eval("Layer"+i+"=new DynLayer("+atribs[0]+","+(rightLayer.getX()+listsLeftMargin+(selColWidth*j))+","+nextRightSpot+","+listItemWidth+","+listItemHeight+","+atribs[4]+",1,0,null,"+atribs[1]+")")
			eval("rightChoices"+j+"[rightChoices"+j+".length] = "+atribs[0])
			choicesLNames[choicesLNames.length] = "Layer"+i
			choicesLAtribs[choicesLAtribs.length] = atribs
			eval("nextRightSpot"+j+"+=listSep;")}}

//Some variables used for drag-n-drop
	startX= 0;
	startY= 0;
	startRight=false;
	startLeft=false;
	hitRight=false;
	hitLeft=false;
	stSelColNum= -1;
	selColNum= -1;

//Mouse Listener to tell us where we dropped our choice
	mouseListener=new EventListener(bigLayer)
		mouseListener.onmouseup=function(e){
			x= e.getX() + bigLayer.getX();
			y= e.getY() + bigLayer.getY();
			if ((!browser1) || browser3) {
				x-= bigLayer.getX();
				y-= bigLayer.getY();}
			if (browser4) {y-=55;}
			lx= rightLayer.getX();
			ly= rightLayer.getY();
			if (x>=lx && x<=(rightLayer.getWidth()+lx) && y>=ly && y<=(rightLayer.getHeight()+ly)) {
				hitRight=true;
				scx1= lx;
				scx2= lx;
				for (var k=0; k<numSelCols; k++) {
					scx1= scx2;
					scx2= scx1 + selColWidth;
					if (k==0 || k==(numSelCols-1)) {scx2 += (listsLeftMargin/2)}
					if (x>=scx1 && x<scx2) {
						selColNum= k;}}
			} else {
				lx= leftLayer.getX();
				ly= leftLayer.getY();
				if (x>=lx && x<=(leftLayer.getWidth()+lx) && y>=ly && y<=(leftLayer.getHeight()+ly)) {
					hitLeft=true;}}
		}

//Listener for each choice(layer) and some variables they use
	for (var i=0; i<choicesLAtribs.length; i++) {
		eval("dragColor="+choicesLAtribs[i][5])
		eval("normColor="+choicesLAtribs[i][4])
		eval("overHtml="+choicesLAtribs[i][2])
		eval("normHtml="+choicesLAtribs[i][1])
		eval("descHtml="+choicesLAtribs[i][3])
		eval("Listener"+i+"=new EventListener(Layer"+i+")")
		eval("Listener"+i+".ondragstart=function(e){dragStart(e,'"+dragColor+"','"+overHtml+"')}")
		eval("Listener"+i+".ondragend=function(e){dragEnd(e,'"+normColor+"','"+normHtml+"')}")
		eval("Listener"+i+".onmouseover=function(e){descLayer.setHTML('<font face=Verdana,Arial,Helvetica,sans-serif size=1 STYLE=cursor:hand;  >"+descHtml+"</font>')}")
		eval("Listener"+i+".onmouseout=function(e){descLayer.setHTML('')}")
		eval("Layer"+i+".addEventListener(Listener"+i+")")}

//Submit Listener
	submitListener=new EventListener(submitLayer)
		submitListener.onclick=function(e){
			popForm();
			if (browser2) {document.choicesForm.submit()}
		}
		submitListener.onmouseup=function(e){
			if (browser1) {popForm();document.cForm.document.choicesForm.submit();}
			else if (browser2) {}
			else {popForm();document.choicesForm.submit();}
		}
	submitLayer.addEventListener(submitListener)

//Listener Helper Functions
	function dragStart(e,color,ovhtml) {
		target=e.getTarget()
		startX=target.getX()
		startY=target.getY()
		lx= rightLayer.getX();
		ly= rightLayer.getY();
		if (startX >= lx && startX <= (rightLayer.getWidth()+lx) && startY >= ly && startY <= (rightLayer.getHeight()+ly)) {
			startRight=true;
			scx1= lx;
			scx2= lx;
			for (var k=0; k<numSelCols; k++) {
				scx1= scx2;
				scx2= scx1 + selColWidth;
				if (startX>=scx1 && startX<scx2) {stSelColNum= k;}}
		} else if (startX >= leftLayer.getX() && startX <= (leftLayer.getWidth()+leftLayer.getX()) && startY >= leftLayer.getY() && startY <= (leftLayer.getHeight()+leftLayer.getY())) {
			startLeft=true;}
		bigLayer.addEventListener(mouseListener)
		target.setZIndex(1)
		if (color) {target.setBgColor(color)}
		if (ovhtml) {target.setHTML(ovhtml)}
	}

	function dragEnd(e,color,nmhtml) {
		target=e.getTarget()
		target.setZIndex(0)
		if (color) {target.setBgColor(color)}
		if (nmhtml) {target.setHTML(nmhtml)}
		bigLayer.removeEventListener(mouseListener)
		if (hitRight) {
			if (startRight) {
				switchCol(target,stSelColNum,selColNum)}
			else {switchToRight(target,selColNum)}}
		else if (hitLeft) {
			if (startLeft) {target.moveTo(startX,startY)}
			else {switchToLeft(target,stSelColNum)}}
		else {target.moveTo(startX,startY)}
		hitRight=false
		hitLeft=false
		startRight=false
		startLeft=false
		stSelColNum= -1;
		selColNum= -1;
	}

//Make the choices dragable
	for (var i=0; i<choicesLNames.length; i++) {
		eval("DragEvent.setDragBoundary("+choicesLNames[i]+")")
		eval("DragEvent.enableDragEvents("+choicesLNames[i]+")")}

//Draw all the layers
	//DynAPI.document.addChild(bigLayer)
	bigLayer.addChild(descBLayer)
	bigLayer.addChild(descLayer)
	bigLayer.addChild(leftBLayer)
	bigLayer.addChild(rightBLayer)
	bigLayer.addChild(leftLayer)
	bigLayer.addChild(rightLayer)
	for (var i=0; i<numSelCols; i++) {
		eval("rightLayer.addChild(colTLayer"+i+")")
		if (i != 0) {eval("rightLayer.addChild(sepLineLayer"+i+")")}}
	bigLayer.addChild(submitLayer)
	bigLayer.addChild(optionsTitleLayer)
	bigLayer.addChild(selectedTitleLayer)
	for (var i=0; i<choicesLNames.length; i++) {
		eval("bigLayer.addChild("+choicesLNames[i]+")")}

//Set resize listener
	if (browser1 || browser2) init();
}

function switchCol(layer, f, k) {
	//Remove from Old Column (f)
		var idToRemove
		eval("var oldChoices= rightChoices"+f)
		for (var i=0; i<oldChoices.length; i++) {if (oldChoices[i] == layer.id) {idToRemove=i}}
		oldChoices.slice(idToRemove,idToRemove+1)
		endArray = oldChoices.slice(idToRemove+1)
		oldChoices.length = idToRemove;
		for(i=0;i<endArray.length;i++){oldChoices[oldChoices.length] = endArray[i]}
	//Add to New Column (k)
		yloc = listItemHeight/2;
		y -= listsTopOMargin + selTopMargin;
		yspot = 0;
		eval("rightChoices= rightChoices"+k)
		if (f==k) {ct= rightChoices.length+1} else {ct= rightChoices.length}
		for (var i=0;i<=ct;i++) {
			if (y <= yloc) {yspot = i; break;}
			else {yspot = i;}
			yloc += listItemSep + listItemHeight;}
		if (f==k && idToRemove < yspot) {yspot--}
		endArray = rightChoices.slice(yspot);
		rightChoices.length = yspot;
		rightChoices[rightChoices.length] = layer.id;
		for(i=0;i<endArray.length;i++){rightChoices[rightChoices.length] = endArray[i]}
	//Shift remaining Old Column choices up
		eval("nextRightSpot"+f+"=rightLayer.getY()+selTopMargin;")
		for (var i=0; i<oldChoices.length; i++) {
			for (var j=0; j<choicesLNames.length; j++) {
				eval("var ourId="+choicesLNames[j]+".id")
				eval("nextRightSpot=nextRightSpot"+f)
				if (oldChoices[i]==ourId) {
					eval(choicesLNames[j]+".moveTo(rightLayer.getX()+listsLeftMargin+"+(f*selColWidth)+","+nextRightSpot+")")
					eval("nextRightSpot"+f+"+=listSep;")}}}
	//Move to appropriate place
		eval("nextRightSpot"+k+"=rightLayer.getY()+selTopMargin;")
		for (var i=0; i<rightChoices.length; i++) {
			for (var j=0; j<choicesLNames.length; j++) {
				eval("var ourId="+choicesLNames[j]+".id")
				eval("nextRightSpot=nextRightSpot"+k)
				if (rightChoices[i]==ourId) {
					eval(choicesLNames[j]+".moveTo(rightLayer.getX()+listsLeftMargin+"+(k*selColWidth)+","+nextRightSpot+")")
					eval("nextRightSpot"+k+"+=listSep;")}}}
}

function switchToRight(layer, k) {
	//Add to right
		yloc = listItemHeight/2;
		y -= listsTopOMargin + selTopMargin;
		yspot = 0;
		eval("rightChoices= rightChoices"+k)
		for (var i=0;i<=rightChoices.length;i++) {
			if (y <= yloc) {yspot = i; break;}
			else {yspot = i;}
			yloc += listItemSep + listItemHeight;}
		endArray = rightChoices.slice(yspot);
		rightChoices.length = yspot;
		rightChoices[rightChoices.length] = layer.id;
		for(i=0;i<endArray.length;i++){rightChoices[rightChoices.length] = endArray[i]}
	//Remove from left
		var idToRemove
		for (var i=0; i<leftChoices.length; i++) {if (leftChoices[i] == layer.id) {idToRemove=i}}
		leftChoices.slice(idToRemove,idToRemove+1)
		endArray = leftChoices.slice(idToRemove+1)
		leftChoices.length = idToRemove;
		for (i=0;i<endArray.length;i++) {leftChoices[leftChoices.length] = endArray[i];}
	//Shift remaining left choices up
		nextLeftSpot=leftLayer.getY()+optionsTopMargin;
		for (var i=0; i<leftChoices.length; i++) {
			for (var j=0; j<choicesLNames.length; j++) {
				eval("var ourId="+choicesLNames[j]+".id")
				if (leftChoices[i]==ourId) {
					eval(choicesLNames[j]+".moveTo(leftLayer.getX()+listsLeftMargin,"+nextLeftSpot+")")
					nextLeftSpot+=listSep;}}}
	//Move to appropriate place
		eval("nextRightSpot"+k+"=rightLayer.getY()+selTopMargin;")
		for (var i=0; i<rightChoices.length; i++) {
			for (var j=0; j<choicesLNames.length; j++) {
				eval("var ourId="+choicesLNames[j]+".id")
				eval("nextRightSpot=nextRightSpot"+k)
				if (rightChoices[i]==ourId) {
					eval(choicesLNames[j]+".moveTo(rightLayer.getX()+listsLeftMargin+"+(k*selColWidth)+","+nextRightSpot+")")
					eval("nextRightSpot"+k+"+=listSep;")}}}
}

function switchToLeft(layer, k) {
	//Add to left
		leftChoices[leftChoices.length] = layer.id
	//Remove from right
		var idToRemove
		eval("rightChoices= rightChoices"+k)
		for (var i=0; i<rightChoices.length; i++) {if (rightChoices[i] == layer.id) {idToRemove=i}}
		rightChoices.slice(idToRemove,idToRemove+1);
		endArray = rightChoices.slice(idToRemove+1);
		rightChoices.length = idToRemove;
		for(i=0;i<endArray.length;i++){rightChoices[rightChoices.length] = endArray[i];}
	//Shift remaining right choices up
		eval("nextRightSpot"+k+"=rightLayer.getY()+selTopMargin;")
		for (var i=0; i<rightChoices.length; i++) {
			for (var j=0; j<choicesLNames.length; j++) {
				eval("var ourId="+choicesLNames[j]+".id")
				eval("nextRightSpot=nextRightSpot"+k)
				if (rightChoices[i]==ourId) {
					eval(choicesLNames[j]+".moveTo(rightLayer.getX()+listsLeftMargin+"+(k*selColWidth)+","+nextRightSpot+")")
					eval("nextRightSpot"+k+"+=listSep;")}}}
	//Move to appropriate place
		layer.moveTo(leftLayer.getX()+listsLeftMargin,nextLeftSpot)
		nextLeftSpot+=listSep
}

function Select (o){
	for (var i=0; i < o.length; i++){o.options[i].selected = true}
}

function popForm() {
	if (browser1) {ourSelect = document.cForm.document.choicesForm.elements['lchoices[]'];}
	else if (browser2) {ourSelect = document.choicesForm.elements['lchoices[]'];}
	else {ourSelect = document.choicesForm.elements['lchoices[]'];}
	ourSelect.options.length = 0;
	for (var i=0; i<leftChoices.length; i++) {
		ourSelect.options[i] = new Option();
		ourSelect.options[i].text = leftChoices[i];
		ourSelect.options[i].value = leftChoices[i];}
	Select(ourSelect);
	for (var k=0; k<numSelCols; k++) {
		if (browser1) {eval("ourSelect = document.cForm.document.choicesForm.elements['rchoices"+k+"[]'];")}
		else if (browser2) {eval("ourSelect = document.choicesForm.elements['rchoices"+k+"[]'];")}
		else {eval("ourSelect = document.choicesForm.elements['rchoices"+k+"[]'];")}
		ourSelect.options.length = 0;
		eval("rightChoices= rightChoices"+k)
		for (var i=0; i<rightChoices.length; i++) {
			ourSelect.options[i] = new Option();
			ourSelect.options[i].text = rightChoices[i];
			ourSelect.options[i].value = rightChoices[i];}
		Select(ourSelect);}
}

%s

</script>
</head>
<body bgcolor="#D2FFED" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" %s >

<!-- START HTML HERE to precede the Option Chooser -->

<div align="center"><font face="Arial, Helvetica, sans-serif" size="1"
color="#828282">Drag and drop portlets to the desired location.</font></div>

<!-- FINISH HTML HERE to precede the Option Chooser -->

<center><table height="%s" width="100%%" cellpadding="0" cellspacing="0">
<tr height="%s"><td height="%s" width="100%%" valign="top">
	<div id="bigL" style="position:absolute;" align="center"></div>
	<div id="bigLN" style="position:relative;" align="center"></div>
</td></tr>
</table></center>

<!-- START HTML HERE to follow the Option Chooser -->

<div align="center"><font face="Arial, Helvetica, sans-serif" size="1" color="#828282">Javascript 
by Options Chooser 1.0. By Dan George (dangeorge.com)</font> </div>
 
<!-- FINISH HTML HERE to follow the Option Chooser -->

<div id='cForm' name='cForm' style="position:absolute;left:-200px;top:-200px;width:600;">
	<form name="choicesForm" id="choicesForm" action="%s/portlets_getInteractive" method="post">
		<select name="lchoices[]" multiple></select>
		<select name="rchoices0[]" multiple></select>
		<select name="rchoices1[]" multiple></select>
		<select name="rchoices2[]" multiple></select>
		<select name="rchoices3[]" multiple></select>
		<select name="rchoices4[]" multiple></select>
		<select name="rchoices5[]" multiple></select>
		<select name="rchoices6[]" multiple></select>
		<select name="rchoices7[]" multiple></select>
		<select name="rchoices8[]" multiple></select>
		<select name="rchoices9[]" multiple></select>
        <input type='hidden' name=cols value=%s> 
        <input type='hidden' name=p value=%s> 
        <input type='hidden' name=windname value=%s>  
	</form>
</div>
%s
</body>
</html>

""" % (scripts_url, scripts_url, context.portlets_user_input(height,content_boxes), scripts_url, scripts_url,
       resizer_script, onload_string, height, height, height, context.absolute_url(), number_cols, p, windname_topass, window_updater)


return page
